- Main Page
- Namespaces
- Classes
- Files

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# Ipopt::AugSystemSolver Class Reference

Base class for Solver for the augmented system. More...

`#include <IpAugSystemSolver.hpp>`

Inheritance diagram for Ipopt::AugSystemSolver:

[legend]
Collaboration diagram for Ipopt::AugSystemSolver:

[legend]
List of all members.

## Public Member Functions
virtual bool | InitializeImpl (const OptionsList &options, const std::string &prefix)=0
| overloaded from AlgorithmStrategyObject
virtual ESymSolverStatus | Solve (const SymMatrix *W, double W_factor, const Vector *D_x, double delta_x, const Vector *D_s, double delta_s, const Matrix *J_c, const Vector *D_c, double delta_c, const Matrix *J_d, const Vector *D_d, double delta_d, const Vector &rhs_x, const Vector &rhs_s, const Vector &rhs_c, const Vector &rhs_d, Vector &sol_x, Vector &sol_s, Vector &sol_c, Vector &sol_d, bool check_NegEVals, Index numberOfNegEVals)
| Set up the augmented system and solve it for a given right hand side.
virtual ESymSolverStatus | MultiSolve (const SymMatrix *W, double W_factor, const Vector *D_x, double delta_x, const Vector *D_s, double delta_s, const Matrix *J_c, const Vector *D_c, double delta_c, const Matrix *J_d, const Vector *D_d, double delta_d, std::vector< SmartPtr< const Vector > > &rhs_xV, std::vector< SmartPtr< const Vector > > &rhs_sV, std::vector< SmartPtr< const Vector > > &rhs_cV, std::vector< SmartPtr< const Vector > > &rhs_dV, std::vector< SmartPtr< Vector > > &sol_xV, std::vector< SmartPtr< Vector > > &sol_sV, std::vector< SmartPtr< Vector > > &sol_cV, std::vector< SmartPtr< Vector > > &sol_dV, bool check_NegEVals, Index numberOfNegEVals)
| Like Solve, but for multiple right hand sides.
virtual Index | NumberOfNegEVals () const =0
| Number of negative eigenvalues detected during last solve.
virtual bool | ProvidesInertia () const =0
| Query whether inertia is computed by linear solver.
virtual bool | IncreaseQuality ()=0
| Request to increase quality of solution for next solve.
Constructors/Destructors
| AugSystemSolver ()
| Default constructor.
virtual | ~AugSystemSolver ()
| Default destructor.
## Private Member Functions
Default Compiler Generated Methods
(Hidden to avoid implicit creation/calling). These methods are not implemented and we do not want the compiler to implement them for us, so we declare them private and do not define them. This ensures that they will not be implicitly created/called.
| AugSystemSolver (const AugSystemSolver &)
| Copy Constructor.
void | operator= (const AugSystemSolver &)
| Overloaded Equals Operator.

## Detailed Description

Base class for Solver for the augmented system.

This is the base class for linear solvers that solve the augmented system, which is defined as

Since this system might be solved repeatedly for different right hand sides, it is desirable to step the factorization of a direct linear solver if possible.

Definition at line 36 of file IpAugSystemSolver.hpp.

## Constructor & Destructor Documentation

Ipopt::AugSystemSolver::AugSystemSolver | ( |  | ) | `[inline]`

Default constructor.

Definition at line 42 of file IpAugSystemSolver.hpp.

virtual Ipopt::AugSystemSolver::~AugSystemSolver | ( |  | ) | `[inline, virtual]`

Default destructor.

Definition at line 45 of file IpAugSystemSolver.hpp.

Ipopt::AugSystemSolver::AugSystemSolver | ( | const AugSystemSolver & |  | ) | `[private]`

Copy Constructor.

## Member Function Documentation

virtual bool Ipopt::AugSystemSolver::InitializeImpl | ( | const OptionsList & | options,
|  | const std::string & | prefix |
| ) |  |  | `[pure virtual]`

overloaded from AlgorithmStrategyObject

Implements Ipopt::AlgorithmStrategyObject.

Implemented in Ipopt::AugRestoSystemSolver, Ipopt::LowRankAugSystemSolver, and Ipopt::StdAugSystemSolver.

virtual ESymSolverStatus Ipopt::AugSystemSolver::Solve | ( | const SymMatrix * | W,
|  | double | W_factor,
|  | const Vector * | D_x,
|  | double | delta_x,
|  | const Vector * | D_s,
|  | double | delta_s,
|  | const Matrix * | J_c,
|  | const Vector * | D_c,
|  | double | delta_c,
|  | const Matrix * | J_d,
|  | const Vector * | D_d,
|  | double | delta_d,
|  | const Vector & | rhs_x,
|  | const Vector & | rhs_s,
|  | const Vector & | rhs_c,
|  | const Vector & | rhs_d,
|  | Vector & | sol_x,
|  | Vector & | sol_s,
|  | Vector & | sol_c,
|  | Vector & | sol_d,
|  | bool | check_NegEVals,
|  | Index | numberOfNegEVals |
| ) |  |  | `[inline, virtual]`

Set up the augmented system and solve it for a given right hand side.

If desired (i.e. if check_NegEVals is true), then the solution is only computed if the number of negative eigenvalues matches numberOfNegEVals.

The return value is the return value of the linear solver object.

Reimplemented in Ipopt::AugRestoSystemSolver, and Ipopt::LowRankAugSystemSolver.

Definition at line 60 of file IpAugSystemSolver.hpp.

References MultiSolve().

Referenced by MultiSolve().

virtual ESymSolverStatus Ipopt::AugSystemSolver::MultiSolve | ( | const SymMatrix * | W,
|  | double | W_factor,
|  | const Vector * | D_x,
|  | double | delta_x,
|  | const Vector * | D_s,
|  | double | delta_s,
|  | const Matrix * | J_c,
|  | const Vector * | D_c,
|  | double | delta_c,
|  | const Matrix * | J_d,
|  | const Vector * | D_d,
|  | double | delta_d,
|  | std::vector< SmartPtr< const Vector > > & | rhs_xV,
|  | std::vector< SmartPtr< const Vector > > & | rhs_sV,
|  | std::vector< SmartPtr< const Vector > > & | rhs_cV,
|  | std::vector< SmartPtr< const Vector > > & | rhs_dV,
|  | std::vector< SmartPtr< Vector > > & | sol_xV,
|  | std::vector< SmartPtr< Vector > > & | sol_sV,
|  | std::vector< SmartPtr< Vector > > & | sol_cV,
|  | std::vector< SmartPtr< Vector > > & | sol_dV,
|  | bool | check_NegEVals,
|  | Index | numberOfNegEVals |
| ) |  |  | `[inline, virtual]`

Like Solve, but for multiple right hand sides.

The inheriting class has to be overload at least one of Solve and MultiSolve.

Reimplemented in Ipopt::StdAugSystemSolver.

Definition at line 109 of file IpAugSystemSolver.hpp.

References DBG_ASSERT, Solve(), and Ipopt::SYMSOLVER_SUCCESS.

Referenced by Solve().

virtual Index Ipopt::AugSystemSolver::NumberOfNegEVals | ( |  | ) | const`[pure virtual]`

Number of negative eigenvalues detected during last solve.

Returns the number of negative eigenvalues of the most recent factorized matrix. This must not be called if the linear solver does not compute this quantities (see ProvidesInertia).

Implemented in Ipopt::AugRestoSystemSolver, Ipopt::LowRankAugSystemSolver, and Ipopt::StdAugSystemSolver.

virtual bool Ipopt::AugSystemSolver::ProvidesInertia | ( |  | ) | const`[pure virtual]`

Query whether inertia is computed by linear solver.

Returns true, if linear solver provides inertia.

Implemented in Ipopt::AugRestoSystemSolver, Ipopt::LowRankAugSystemSolver, and Ipopt::StdAugSystemSolver.

virtual bool Ipopt::AugSystemSolver::IncreaseQuality | ( |  | ) | `[pure virtual]`

Request to increase quality of solution for next solve.

Ask underlying linear solver to increase quality of solution for the next solve (e.g. increase pivot tolerance). Returns false, if this is not possible (e.g. maximal pivot tolerance already used.)

Implemented in Ipopt::AugRestoSystemSolver, Ipopt::LowRankAugSystemSolver, and Ipopt::StdAugSystemSolver.

void Ipopt::AugSystemSolver::operator= | ( | const AugSystemSolver & |  | ) | `[private]`

Overloaded Equals Operator.

The documentation for this class was generated from the following file:

- /home/coin/SVN-release/Ipopt-3.2.1/Ipopt/src/Algorithm/IpAugSystemSolver.hpp